SystemOrganization addCategory: #'GT-Inspector'!

!ContextPart methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:13'!
gtInspectorVariableValuePairs
	"We override the variables with context specific ones"
	| tempIndex |
	tempIndex := 0.
	^ super gtInspectorVariableValuePairs
		addAll:
				(self tempNames
						collect: [ :tempName | 
							tempIndex := tempIndex + 1.
							('[' , tempName , ']') -> (self debuggerMap namedTempAt: tempIndex in: self) ]);
		yourself! !

!FileReference class methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/2/2014 21:11'!
gtExampleDirectory
	<gtExample>
	| directory subDirectory |
	directory := FileSystem memory workingDirectory / 'directory'.
	directory createDirectory.
	directory / 'file1.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File1 contents' ].
	directory / 'file2.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File2 contents' ].
	subDirectory := (directory / 'subdirectory') createDirectory.
	subDirectory / 'file3.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File3 contents' ].
	^ directory! !

!FileReference class methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/2/2014 22:14'!
gtExampleGif
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.gif' 
		writeStreamDo: [ :stream |
			GIFReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/2/2014 22:13'!
gtExamplePng
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.png' 
		writeStreamDo: [ :stream |
			PNGReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/2/2014 20:22'!
gtExampleText
	<gtExample>
	^ FileSystem memory workingDirectory / 'sample.txt' 
		writeStreamDo: [ :stream |
			stream nextPutAll: self comment ];
		yourself! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/2/2014 22:41'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 10>
	composite rubricText
			title: 'Contents';
			display: [ 
				self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 5000) asString]
						on: Error 
						do: [ (stream binary next: 5000) asString ].
					stream size > 5000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ] ];
			withLineNumbers: true;
			when: [ self isFile ]! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/2/2014 22:13'!
gtInspectorGifIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Morph';
			display: [ self binaryReadStreamDo: [ :stream | GIFReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageGif ] ]! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	^ composite list 
		title: 'Items';
		display: [ 
			| children |
			children := self directories, self files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		format: [:each | (self isChildOf: each) 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousOpen ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [self isDirectory and: [self hasChildren]]! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/2/2014 22:13'!
gtInspectorJpegIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Morph';
			display: [ self binaryReadStreamDo: [ :stream | JPEGReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageJpeg ] ]! !

!FileReference methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/2/2014 22:13'!
gtInspectorPngIn: composite
	<gtInspectorPresentationOrder: 10>
	composite morph
			title: 'Morph';
			display: [ self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imagePng ] ]! !

!String class methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 23:05'!
gtInspectorFourtyTwo
	<gtExample>
	^ '42'! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a String"! !

!String methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/22/2013 00:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'String'! !

!FileSystem class methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/7/2014 07:51'!
gtExampleZip
	<gtExample>
	| zipFile zip |
	zipFile := FileSystem memory workingDirectory / 'test.zip'.
	zip := (FileSystem zip: zipFile) open.
	zip / 'sample.txt'
		writeStreamDo: [ :stream |
				stream nextPutAll: self comment ];
			yourself.
	^ zip! !

!FileSystem methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorRootItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self root gtInspectorItemsIn: composite)
		title: 'Root directory'! !

!FileSystem methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorWorkingDirectoryItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self workingDirectory gtInspectorItemsIn: composite)
		title: 'Working directory'! !

!ComposableModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/2/2013 16:38'!
gtInspectorModelNestingIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Nesting';
		display: [ :root | { 'root' -> self } ];
		children: [ :each | 
			each value class allInstVarNames 
				collect: [ :iv | iv->(each value instVarNamed: iv) ]
				thenSelect: [ :association | 
					(association value isKindOf: ComposableModel) 
						and: [ (#('owner' 'window') includes: association key) not ] ] ];
		format: [ :association | association key , ': ' , association value asString ];
		send: #value! !

!ComposableModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/3/2013 17:49'!
gtInspectorSpecIn: composite
	<gtInspectorPresentationOrder: 30>
	composite spec 
		title: 'Preview';
		when: [ self widget notNil ]! !

!Morph methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/6/2014 14:19'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 95>
	self kmDispatcher gtInspectorMappingsIn: composite! !

!Morph methodsFor: '*GT-Inspector' stamp: 'TudorGirba 1/10/2014 10:44'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:each | self imageForm asMorph ];
		act: [ :pres | self exportAsPNG ] entitled: 'Export as PNG'! !

!Morph methodsFor: '*GT-Inspector' stamp: 'TudorGirba 1/2/2012 03:22'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notEmpty ]! !

!Bitmap methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!KMRepository methodsFor: '*gt-inspector' stamp: 'TudorGirba 2/5/2014 15:12'!
gtInspectorGlobalsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite tree 
		title: 'Globals';
		display: #globalCategories;
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		children: [ :item :treePresentation :level |
			level > 1 
				ifTrue: [ #() ]
				ifFalse: [ item allEntries keymaps  ] ];
		format: #gtDisplayString! !

!KMRepository methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/10/2014 23:34'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite tree 
		title: 'Mappings';
		display: #categories;
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		children: [ :item :treePresentation :level |
			level > 1 
				ifTrue: [ #() ]
				ifFalse: [ item allEntries keymaps  ] ];
		format: #gtDisplayString! !

!ROMondrianViewBuilder methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 19:30'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		view: self! !

!KMCategory methodsFor: '*GT-Inspector' stamp: 'TudorGirba 1/20/2014 08:20'!
gtDisplayOn: stream
	^ stream nextPutAll: self name asString! !

!KMCategory methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/6/2014 14:14'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Mappings';
		display: [ self allEntries keymaps ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		format: #gtDisplayString! !

!WindowModel methodsFor: '*gt-inspector' stamp: 'TudorGirba 4/2/2013 16:31'!
gtInspectorModelNestingIn: composite
	self model gtInspectorModelNestingIn: composite! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self compiledMethod implementors ]! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:09'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self compiledMethod senders ]! !

!RGMethodDefinition methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/30/2013 22:19'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 20>
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self sourceCode ];
		act: [ :text | self methodClass compile: text text notifying: nil ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ self browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'! !

!GLMPane methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 13:38'!
gtInspectorPortsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Ports';
		display: [ self ports ];
		column: 'Port' evaluated: [ :each | each name ];
		column: 'Value' evaluated: [ :each | each value asString ]! !

!CompiledMethod class methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/29/2014 21:43'!
gtExampleSimple
	<gtExample>
	^ self class>>#gtExampleSimple! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/22/2013 07:54'!
gtDisplayOn: stream
	^ self printOn: stream! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/23/2011 07:30'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Bytecode';
		display: [:anObject | anObject symbolic ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'AndreiChis 12/19/2013 16:33'!
gtInspectorIrIn: composite
	<gtInspectorPresentationOrder: 35> 
	composite text 
		title: 'Ir';
		display: [ :anObject || string |
				string := anObject ir longPrintString.
				string copyFrom: 2 to: string size ]! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'AndreiChis 1/29/2014 17:56'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite tabulator 
		title: 'Pragmas';
		when: [ :x | x pragmas notEmpty ];
		with: [ :t |  
			t row: #pragmas; row: #methods.
			t transmit to: #pragmas; andShow: [:a | 
				a list
					title: 'Pragmas';
					display: [ :method | method pragmas ];
					when: [ :x | x pragmas notEmpty ] ].
			t transmit from: #pragmas; to: #methods; andShow: [:a | 
				a list 
					title: 'Methods';
					display: [ :pragma | 
						| methods | 
						methods := OrderedCollection new.
						Object withAllSubclassesDo: [ :each | 
							methods addAll: ((Pragma allNamed: pragma keyword in: each) collect: #method) ].
						methods ];
					format: #selector ].
			t transmit
				toOutsidePort: #selection;
				from: #methods port: #selection
		];
		startOn: self! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/30/2013 22:15'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self getSource ];
		act: [ self browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!CompiledMethod methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:29'!
gtInspectorVariableValuePairs
	| literalIndex |
	literalIndex := 0.
	^ Set new 
		add: ( 'header' -> self headerDescription );
		addAll: ( self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ] );
		add: ( 'all bytecodes' -> self symbolic );
		yourself
! !

!Symbol methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self systemNavigation allImplementorsOf: self ];
		when: [ (self systemNavigation allImplementorsOf: self) notEmpty ];
		showOnly: 30! !

!Symbol methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self systemNavigation allSendersOf: self ];
		when: [ (self systemNavigation allSendersOf: self) notEmpty ];
		showOnly: 30! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 14:05'!
children
	^ self sonsOver: 0! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 22:28'!
gtDisplayIdentifierOn: aStream
	class gtDisplayOn: aStream.
	self method methodClass ~~ class 
		ifTrue: [ aStream nextPut: $(; print: self method methodClass; nextPut: $) ].
	aStream 
		nextPutAll: '>>';
		store: self method selector! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 22:29'!
gtDisplayOn: aStream
	self gtDisplayIdentifierOn: aStream.
	aStream 
		nextPutAll: ' (';
		nextPutAll: self tally printString;
		nextPutAll: ')'! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 23:01'!
gtInspectorMessageTreeIn: composite
	<gtInspectorPresentationOrder: 40>
	| methods normalizer |
	methods := self withDeepCollect: #children.
	normalizer := RONColorLinearNormalizer 
						inContext: methods 
						withCommand: #tally 
						lowColor: Color gray 
						highColor: Color red.
	^ (composite tree)
		title: 'Tree';
		children: [ :each | each children ];
		"rootsExpanded;"
		format: [ :each | 
			Text 
				string: each gtDisplayString
				attributes: { TextColor color: (normalizer roValue: each)}];
		when: [ self children notEmpty ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		morphicSelectionAct: [ :list | GTUtils browseMethod: list selection method ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse (b)'
		! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 21:36'!
gtInspectorPerformanceChartIn: composite
	<gtInspectorPresentationOrder: 40>
	| metric |
	metric := #localTally.
	^ composite graphET
		title: 'Top tallies';
		diagram: [ :renderer :presentation |
			GTInspectorMessageTallyCharter new 
				performanceOf: self 
				with: renderer 
				in: presentation ];
		when: [ self children notEmpty ]! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 14:10'!
gtInspectorReportIn: composite
	<gtInspectorPresentationOrder: 60>
	^ composite text
		title: 'Report';
		display: [ String streamContents: [:s | self report: s ] ]! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/4/2014 22:56'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 50>
	^ self method ifNotNil: [
		self method gtInspectorSourceIn: composite]! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 14:05'!
localTally
	^ self children 
		inject: self tally
		into: [ :diff :each | diff - each tally ]! !

!MessageTally methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 14:05'!
localTime
	^ self children
		inject: self time 
		into: [ :diff :each | diff - each time ]! !

!Set methodsFor: '*gt-inspector' stamp: 'TudorGirba 5/30/2012 06:49'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:set | set asOrderedCollection]! !

!ROView methodsFor: '*gt-inspector' stamp: 'TudorGirba 9/6/2013 20:35'!
gtInspectorElementsHierarchyIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Elements';
		display: [ :each | {each} ];
		children: #elements! !

!ROView methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 20:34'!
gtInspectorViewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite roassal 
		title: 'View';
		initializeView: [self]! !

!MethodContext methodsFor: '*gt-inspector' stamp: 'TudorGirba 11/13/2013 06:44'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!KMDispatcher methodsFor: '*GT-Inspector' stamp: 'TudorGirba 2/6/2014 14:16'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite tree 
		title: 'Mappings';
		display: [self targets collect: #category];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		children: [ :item :treePresentation :level |
			level > 1 
				ifTrue: [ #() ]
				ifFalse: [ item allEntries keymaps  ] ];
		format: #gtDisplayString! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/24/2013 14:07'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: [ :anObject | self size asString, ' items' ];
		display: [ self associations];
		column: 'Key' evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | (selection notNil and: [selection size = 1]) 
				ifTrue: [selection anyOne value] 
				ifFalse: [selection collect: #value] ];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:29'!
gtInspectorVariableValuePairs  
	^ Set new 
		add: ( 'tally' -> self size );
		add: ( 'array' -> self array );
		yourself
! !

!Date methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/19/2014 22:50'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 40>
	composite morph
		title: 'Preview';
		morph: [ CalendarMorph on: self ]! !

!Color methodsFor: '*gt-inspector' stamp: 'TudorGirba 11/18/2013 11:46'!
gtInspectorColorIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph 
		title: 'Color';
		display: [ BorderedMorph new color: self ]! !

!Text methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:45'!
gtInspectorItemsIn: composite
	"No items presentation for a Text"! !

!Text methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/22/2013 00:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>  
	 composite text
		title: 'Text';
		format: self! !

!Collection methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:21'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (composite list)
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | self ];
		beMultiple;
		withSmalltalkSearch;		
		format: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		send: [ :result | (result notNil and: [result size = 1]) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!GLMSystemWindow methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ (self model 
		gtInspectorOpenTreeIn: composite)
		title: 'Browser tree'! !

!KMKeymap methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/10/2014 07:07'!
gtDisplayOn: aStream
	aStream 
		nextPutAll: self name gtDisplayString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut gtDisplayString;
		nextPutAll: ' do ' ;
		nextPutAll: self action gtDisplayString! !

!GLMCompositePresentation methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMCompositePresentation methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/17/2013 16:18'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

GLMCompositePresentation subclass: #GTExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTExamplesBrowser commentStamp: 'TudorGirba 1/28/2014 23:12' prior: 0!
A simple browser showing the list of examples for a given class.!

!GTExamplesBrowser methodsFor: 'building' stamp: 'TudorGirba 2/7/2014 06:18'!
compose
	self title: 'E.g.'.
	self when: [ :class | (self examplesFor: class) notEmpty ].
	self list
		display: [ :class | self examplesFor: class ];
		format: [ :pragmaExamplePair | pragmaExamplePair value gtDisplayString ];
		send: [ :pragmaExamplePair | pragmaExamplePair value ];
		morphicSelectionAct: [ :list | 
			list rawSelection key method browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse source';
		selectionPopulate: #selection 
			on: $o 
			entitled: 'Open source' 
			with: [ :list | list rawSelection key method asRingDefinition ]! !

!GTExamplesBrowser methodsFor: 'private' stamp: 'TudorGirba 2/7/2014 06:15'!
examplesFor: anObject
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtExample 
				in: anObject class.
	^ pragmas collect: [ :eachPragma | eachPragma -> (anObject perform: eachPragma selector) ]
! !

GLMCompositePresentation subclass: #GTInspector
	instanceVariableNames: ''
	classVariableNames: 'GTNumberOfInspectorPanes'
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspector commentStamp: 'TudorGirba 8/21/2011 16:57' prior: 0!
This is meant to be used for inspecting objects. It offers multiple views and it uses a finder as a navigation. One particular feature is that you can use the evaluator tab to enter code, and evaluating it results in opening another pane to the right.

The object finder asks dynamically the object for the actual presentations that are displayed in each pane.

Example:
self openOn: Smalltalk.

Register it as a replacement for explorer:
self registerToolsOn: Smalltalk tools.!

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
explore: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'inspecting' stamp: 'TudorGirba 1/21/2014 22:21'!
gtInspectorExtensionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Extensions';
		display: [ 
			(Object withAllSubclasses flatCollect: [ :each |
					(Pragma
						allNamed: #gtInspectorPresentationOrder:
						in: each) 
							collect: [:p | p method asRingDefinition] ]) sorted ];
		format: [ :each | each gtDisplayString ];
		filterOn: [ :text :each | 
			each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!GTInspector class methodsFor: 'class initialization' stamp: 'TudorGirba 10/7/2012 22:50'!
initialize 
	self numberOfInspectorPanes: 2! !

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/1/2013 22:16'!
inspect: anObject 
	self openOn: anObject.
	^ anObject! !

!GTInspector class methodsFor: 'openning' stamp: 'AndreHora 11/2/2013 00:17'!
inspector: anObject

	^ self inspect: anObject! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes
	^ GTNumberOfInspectorPanes ! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/7/2012 22:46'!
numberOfInspectorPanes: anInteger
	GTNumberOfInspectorPanes := anInteger ! !

!GTInspector class methodsFor: 'openning' stamp: 'TudorGirba 11/25/2012 22:53'!
openOn: anObject 
	^ self new openOn: anObject! !

!GTInspector class methodsFor: 'tools registry' stamp: 'TudorGirba 11/1/2013 22:17'!
registerToolsOn: registry
	"self registerToolsOn: Smalltalk tools " 
	registry register: self as: #inspector
! !

!GTInspector class methodsFor: 'settings' stamp: 'TudorGirba 10/8/2012 20:13'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder group: #glamorousInspector)
		label: 'Glamorous Inspector';
		with: [
			(aBuilder setting: #numberOfInspectorPanes)
				target: self; 
				label: 'Number of inspector panes';
		 		description: 'Specifies the maximum number of panes that are visible at every moment in a Glamorous Inspector.'.]! !

!GTInspector methodsFor: 'building' stamp: 'TudorGirba 11/14/2013 06:15'!
compose
	self title: [:anObject | 'Inspector on ', (self printObjectAsAnItem: anObject)].
	self act: [:b | b update] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Update'.
	self finder with: [:browser | 
		browser fixedSizePanes: self class numberOfInspectorPanes.
		browser show: [ :a :each | 
			a title: [ :anObject | self printObjectAsAnItem: anObject ].
			a 
				morphicAct: [:composite | composite entity browse]
				icon: GLMUIThemeExtraIcons glamorousBrowse 
				entitled: 'Browse'.

			a dynamic display: [ :x | 
				GLMCompositePresentation new with: [:d | each gtInspectorPresentationsIn: d ] ] ] ]! !

!GTInspector methodsFor: 'opening' stamp: 'TudorGirba 8/21/2011 08:56'!
openExplorerFor: anObject
	"this method is needed for compatibility with ObjectExplorer"
	self openOn: anObject! !

!GTInspector methodsFor: 'private' stamp: 'TudorGirba 1/28/2014 22:59'!
printObjectAsAnItem: anObject 
	|  stream  |
	stream := String new writeStream.
	stream
		nextPutAll: (anObject class name first isVowel 
				ifTrue: [ 'an ' ]
				ifFalse: [ 'a ' ]);
		nextPutAll: anObject class name.
	stream 
		nextPutAll: ' (';
		nextPutAll: (GTObjectPrinter new asTruncatedTextFrom: anObject) asString;
		nextPut: $).
	^ stream contents! !

GLMCompositePresentation subclass: #GTInspectorMessageTallyCharter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTInspectorMessageTallyCharter commentStamp: 'TudorGirba 1/18/2014 14:28' prior: 0!
Helper class for displaying charts specific for a MessageTally.!

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 14:30'!
nestingMapOf: aMessageTally on: view
	"This is provides a treemap visualization of a message tally"
		
	| builder methods methodNestings |
	builder := ROTreeMapBuilder new.
	builder weightBlock: [ :el | el children size max: 1 ].
	methods := OrderedCollection new.
	methodNestings := OrderedCollection new.
	aMessageTally 
		deep: #children
		do: [ :each | methods add: each ]
		relationDo: [ :from :to | methodNestings add: from->to ].
	builder nodes: methods.
	builder nestingFromAssociations: methodNestings.
	builder fillNodes: [:x | true] withColor: (RONColorLinearNormalizer inContext: methods withCommand: [:m | (m isKindOf: ROElement) ifTrue: [ m model localTally ] ifFalse: [m localTally] ]  lowColor: Color white highColor: Color red ).
	builder withShadedFrames.
	builder drawOn: view raw! !

!GTInspectorMessageTallyCharter methodsFor: 'visualization' stamp: 'TudorGirba 1/18/2014 22:30'!
performanceOf: aMessageTally with: renderer in: presentation
	"Displays a Graph-ET chart showing the top 20 most costly methods within a MessageTally.
	For each method it sows the number of occurences of a method and the 
	total amount of local tallies for that method. Useful for identifying outliers 
	within one execution."
	
	| all diag diag2 grouped metric |
	metric := #localTally.
	all := aMessageTally deepCollect: [ :each | each sonsOver: 1 ].
	grouped := (all groupedBy: [ :each | String streamContents: [:s | each gtDisplayIdentifierOn: s] ]) 
						associations sorted: [:a :b | 
									(a value sumNumbers: metric) > 
									(b value sumNumbers: metric) ].
	grouped := (grouped first: (20 min: grouped size)) select: [:each | (each value sumNumbers: metric) > 0].
	diag := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Locations';
		modelLabels: [:each | each key ];
		x: [:each | each value size];
		valueAxis;
		color: Color veryLightGray;
		axisColor: Color veryLightGray;
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	diag2 := (GETHorizontalBarDiagram new)
		xAxisLabel: 'Tallies';
		x: [:each | each value sumNumbers: metric];
		regularAxis;
		xAxisOnTop;
		gapFraction: 1 / 2;
		color: (Color red);
		axisColor: (Color red);
		on: ROMouseClick do: [:event | presentation selection: event model value ];
		models: grouped.
	(renderer unionDiagram)
		add: diag;
		add: diag2! !

GLMCompositePresentation subclass: #GTObjectVariablesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectVariablesBrowser commentStamp: 'TudorGirba 8/22/2011 12:52' prior: 0!
This is a helper browser for the main view in the GTInspector.

Example:
self openOn: Smalltalk!

!GTObjectVariablesBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 22:38'!
compose
	self title: 'State'.
	self tabulator with: [ :browser |
		browser row: #variables; row: #evaluator.
		browser transmit to: #variables; andShow: [:a | 
			self variablesIn: a ].
		browser transmit to: #evaluator; andShow: [:a | 
			self evaluatorIn: a ].
		browser transmit from: #variables; toOutsidePort: #selection.
		browser transmit from: #evaluator; toOutsidePort: #selection ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 2/2/2014 14:06'!
evaluatorIn: composite
	^ (composite smalltalkCode)
		doItReceiver: #yourself;
		display: [ :object | 
			String streamContents: [ :stream | 
				stream 
					nextPutAll: (self printStringOf: object);
					cr;
					nextPutAll: (GTSnippets snippetAt: object class)] ];
		selectionPopulate: #selection
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text :object | 
				GTSnippets snippetAt: object class put: (self stringWithoutInitialCommentFrom: text text asString).
				Compiler evaluate: text selectedText for: object logged: false ] ! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 11/27/2013 14:53'!
printStringOf: anObject
	^ [(anObject printString contractTo: 200) asSmalltalkComment] 
			on: Error 
			do: ['"Error printing. Try self printString to debug"']! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 2/2/2014 15:01'!
stringWithoutInitialCommentFrom: aString
	^ aString first = $" 
		ifFalse: [ aString trimBoth ]
		ifTrue: [ 
			(aString
				copyFrom: (aString findAnySubStr: '"' startingAt: 2) + 1 
				to: aString size) trimBoth ]! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 12/25/2013 15:37'!
variableValuePairsFor: anObject
	^ anObject gtInspectorVariableValuePairs asSortedCollection asOrderedCollection 
		addFirst: 'self' -> anObject; 
		yourself! !

!GTObjectVariablesBrowser methodsFor: 'private building' stamp: 'TudorGirba 1/12/2014 13:12'!
variablesIn: composite
	^ composite table
		showOnly: 50;
		display: [ :anObject | self variableValuePairsFor: anObject ];
		column: 'Variable' evaluated: [:assoc | GTObjectPrinter new asNonTruncatedTextFrom: assoc key ];
		column: 'Value' evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect';
		selectionAct: [:list | 
			((list selection pointersToExcept: { list selection })
									reject: [ :each | each pointsOnlyWeaklyTo: list selection ]) inspect ] 
			on: $t
			entitled: 'Open pointers to'! !

GLMCompositePresentation subclass: #GTSimpleMethodsBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleMethodsBrowser commentStamp: 'TudorGirba 1/18/2014 14:29' prior: 0!
This browser is used to browse the class structure of every object in the inspector.

Example:
self openOn: World!

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 11/24/2013 08:37'!
accumulatedSourceOf: m for: object in: composite
	composite accumulator with: [ :acc | 
		acc show: [ :a |
			a title: [ :method | method selector ].
			self sourceOf: m for: object in: a ] ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:05'!
classesIn: a
	^ a list
		display: [ :object | 
			| all |
			all := OrderedCollection new.
			object class withAllSuperclassesDo: [:each | all add: each ].
			all ];
"		initialize: [ :list | list selection: list entity class ];"
		format: [ :class | class name ];
		morphicSelectionAct: [ :list | Smalltalk tools browser fullOnClass: list selection ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse'! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/17/2013 10:23'!
compose
	self title: 'Methods'.
	self tabulator with: [ :browser |
		browser
			row: [ :r | r column: #classes; column: #methods span: 3 ];
			row: #source.
		browser transmit
			to: #classes;
			andShow: [ :a | self classesIn: a ].
		browser transmit
			to: #classes port: #selection;
			transformed: [:each | each class ].
		browser transmit
			fromOutsidePort: #entity;
			from: #classes;
			to: #methods;
			andShow: [ :a | self methodsIn: a ].
		browser transmit
			from: #methods;
			fromOutsidePort: #entity;
			to: #source;
			when: [ :method | method notNil ];
			andShow: [ :a :method :object | self sourceOf: method for: object in: a ].
		browser transmit
			toOutsidePort: #selection;
			from: #methods port: #evaluatedObject.
		browser transmit
			toOutsidePort: #selection;
			from: #source port: #evaluatedObject.
	]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 7/15/2012 18:07'!
evaluationAction
	^ GLMGenericAction new
		action: [ :listPresentation :obj | 
					| result |
					result := obj perform: listPresentation selection selector.
					(listPresentation pane port: #evaluatedObject) value: result ];
		shortcut: $o;
		title: 'Do it and open';
		yourself! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 7/15/2012 18:58'!
methodActionsFor: aMethod
	^ aMethod selector isUnary
		ifTrue: [ Array with: self evaluationAction ]
		ifFalse: [ #() ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 12/17/2013 08:00'!
methodsIn: a
	^ a list
		display: [ :object :class | class methods collect: #asRingDefinition];
		filterOn: [ :text :each | (text , '*') match: each selector ];
		tags: [ :method | method category ];
		sorted: [ :method1 :method2 | method1 selector < method2 selector ];
		format: [ :method | method selector ];
		morphicSelectionAct: [ :list :object :class | 
			Smalltalk tools browser 
				fullOnClass: class 
				selector: list selection selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			on: $b
			entitled: 'Browse';
		dynamicActionsOnSelection: [ :list | self methodActionsFor: list selection ]! !

!GTSimpleMethodsBrowser methodsFor: 'building' stamp: 'TudorGirba 1/18/2014 14:24'!
sourceOf: method for: object in: composite
	^ composite smalltalkCode
		display: [ :m | m sourceCode ];
		smalltalkClass: [ :m | m methodClass ];
		doItReceiver: [ object ];
		selectionPopulate: #evaluatedObject
			on: $o
			entitled: 'Do it and open (o)'
			with: [ :text | Compiler evaluate: text selectedText for: object logged: false ];
		act: [ :text :m | self updateOuterPaneFrom: text for: method ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ :text :m | 
			Smalltalk tools browser 
				fullOnClass: m methodClass 
				selector: m selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		act: [ :text :m | 
			(text pane port: #evaluatedObject) value: m ]
			icon: GLMUIThemeExtraIcons glamorousInspect
			entitled: 'Inspect'! !

!GTSimpleMethodsBrowser methodsFor: 'private' stamp: 'TudorGirba 12/17/2013 15:27'!
updateOuterPaneFrom: text for: method
	"this is a utility method to tell the pane surrounding the browser to update.
	The reason we do that is to support the use case of updating the GTInspector from
	the editor by modifying code directly in the Inspector."
	
	| outerPane newMethod |
	newMethod := method methodClass compile: text text notifying: nil.
	outerPane := text pane browser pane.
	outerPane update.
	self
		flag:
			'This is a huge hack because of so many reasons:
				- the presentation accesses the state of the outer browser directly
				- the presentation depends on the implementation of the browser 
				It should be solved through transmissions.
				
				But, it works for now and the browser is reasonably updated'.
	^ outerPane
		withAllPanesAndPresentationsDo: [ :child | 
			(child isKindOf: self class)
				ifTrue: [ 
					((child first paneNamed: #classes) port: #selection) value: method methodClass.
					((child first paneNamed: #methods) port: #selection)
						value:
							((child first paneNamed: #methods) presentations first displayedValue detect: [ :each | each selector = newMethod ]) ] ]! !

GLMCompositePresentation subclass: #GTSimpleRBTreeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTSimpleRBTreeBrowser commentStamp: '<historical>' prior: 0!
This is a simple browser that displays the rb tree and previews each node on the source code.

Example:
self openOn: (self>>#compose) parseTree!

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:09'!
compose
	self title: 'Tree'.
	self tabulator with: [ :browser |
		browser
			row: #tree;
			row: #source.
		browser transmit
			to: #tree;
			andShow: [ :a | self treeIn: a ].
		browser transmit
			to: #source;
			andShow: [ :a | self sourceIn: a ].
		browser transmit
			from: #tree;
			to: #source port: #selectionInterval;
			transformed: [ :rbNode | rbNode sourceInterval ].
		browser transmit
			toOutsidePort: #selection;
			from: #tree port: #selectedNode ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 11/29/2013 14:56'!
sourceIn: a
	^ a smalltalkCode 
		smalltalkClass: [ :each | each parents first methodClass ]; 
		display: [ :each | each source ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:17'!
treeIn: a
	^ a tree
		rootsExpanded;
		display: [ :anObject | {anObject} ];
		children: [ :each | each children ];
		selectionPopulate: #selectedNode
			on: $o
			entitled: 'Open'
			with: [ :tree | tree selection ];
		format: [ :each | 
					String
						streamContents: [ :stream | 
							stream
								nextPutAll: each class name;
								nextPut: $(;
								nextPutAll: ((each formattedCode truncateTo: 50) copyReplaceAll: String cr with: String space);
								nextPut: $) ] ]! !

!Float methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:13'!
gtInspectorVariableValuePairs
	"We override the default variables to add significand and exponent"
	| bindings |
	bindings := super gtInspectorVariableValuePairs.
	bindings
		add: 'significand' -> self significand;
		add: 'exponent' -> self exponent.
	^ bindings! !

!ReadStream methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 13:00'!
gtInspectorStreamStateIn: composite
	<gtInspectorPresentationOrder: 50>
	(composite wrapper with: [ :w | 
		w title: 'Contents'.
		w show: [ :a | 
			a text
				display: [ self contents ];
				initialize: [ :aPresentation | 
					aPresentation selectionInterval: (1 to: self position) ] ] ])
		startOn: self! !

!TraitDescription methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/4/2013 10:51'!
gtInspectorUsersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 	
		title: 'Users';
		display: [ 
			Smalltalk allClasses select: [ :class |
			   class traitComposition traits includes: self ] ]! !

!Form methodsFor: '*gt-inspector' stamp: 'TudorGirba 8/21/2011 09:05'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	composite morph 
		title: 'Morph';
		display: [:object | object asMorph]! !

!Integer methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 23:13'!
gtInspectorVariableValuePairs
	"We override the default variables to add representations for various bases"
	^ super gtInspectorVariableValuePairs
		add: 'hex' -> self printStringHex;
		add: 'octal' -> (self printStringBase: 8);
		add: 'binary' -> (self printStringBase: 2);
		yourself! !

!SmallDictionary methodsFor: '*gt-inspector' stamp: 'TudorGirba 6/1/2012 22:10'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:smallDictionary  | smallDictionary associations asOrderedCollection]! !

!RBProgramNode methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/18/2014 11:25'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite custom: (GTSimpleRBTreeBrowser new  startOn: self)! !

!Announcer methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 21:11'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Subscriptions';
		display: [ self subscriptions glmSubscriptions ];
		column: 'Subscriber' evaluated: [ :each | each subscriber asString ];
		column: 'Announcement' evaluated: [ :each | each announcementClass name ];
		column: 'Kind' evaluated: [ :each | each class name ];
		act: [ :table | 
			self subscriptions reset.
			table reset ] icon: GLMUIThemeExtraIcons glamorousCancel entitled: 'Reset';
		selectionAct: [ :table | 
			self subscriptions remove: table selection.
			table update ] entitled: 'Remove subscription'! !

!Class methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 23:10'!
gtInspectorExamplesIn: composite
	"This provides a list of example objects for the current class"
	<gtInspectorPresentationOrder: 20>
	composite custom: (GTExamplesBrowser new startOn: self)! !

!GLMBrowser methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMBrowser methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/18/2013 05:26'!
gtInspectorOpenTreeIn: composite
	<gtInspectorPresentationOrder: 30>  
	^ composite roassal 
		title: 'Tree';
		painting: [:view :b | 
			self viewTreeOn: view ]! !

!ByteArray methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/21/2013 22:44'!
gtInspectorItemsIn: composite
	"No items presentation for a ByteArray"! !

!SequenceableCollection methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/30/2013 15:03'!
gtInspectorItemsIn: composite
	^ composite table
		title: [ :anObject | anObject size asString, ' items' ];
		display: [ :aCollection | (1 to: self size) collect: [ :index | index -> (self at: index) ] ];
		beMultiple;
		searchOn: [:text :each | 
			Compiler evaluate: ' | entity each | each := self. entity := each.', text for: each value logged: false];
		column: 'Item' evaluated: [ :assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		column: 'Index' evaluated: [ :assoc | assoc key asString ];
		send: [ :result | 
			result isNil
				ifTrue: [ nil ]
				ifFalse: [ result value size = 1 
					ifTrue: [result anyOne value]  
					ifFalse: [self species withAll: (result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Pragma class methodsFor: '*gt-inspector' stamp: 'TudorGirba 10/4/2013 22:16'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite table 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			(pragmas groupedBy: #keyword) associations sorted: [ :a :b | 
				a key < b key ]
		];
		column: 'Keyword' evaluated: [ :each | each key ];
		column: 'Instances' evaluated: [ :each | each value size asString ];
		send: #value! !

!Pragma methodsFor: '*GT-Inspector' stamp: 'TudorGirba 10/6/2013 22:09'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!ZnMessage methodsFor: '*gt-inspector' stamp: 'TudorGirba 7/16/2013 22:17'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers headers gtInspectorItemsIn: composite) 
		display: [:anObject | self headers headers associations ];
		title: [:anObject | self headers headers size asString , ' header items' ]! !

Object subclass: #GTObjectPrinter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

!GTObjectPrinter commentStamp: 'TudorGirba 1/18/2014 14:29' prior: 0!
This is a utility class for printing objects to Text or String.!

!GTObjectPrinter methodsFor: 'printing' stamp: 'TudorGirba 12/23/2013 09:17'!
asNonTruncatedTextFrom: anObject
	^ [ Text fromString: (anObject asString replaceAll: String cr with: String space) ] 
			on: Error 
			do: [ Text string: 'error printing' attribute: TextColor red ]! !

!GTObjectPrinter methodsFor: 'printing' stamp: 'TudorGirba 12/22/2013 08:00'!
asTruncatedTextFrom: anObject
	^ [ Text fromString: ((anObject gtDisplayString contractTo: 50) replaceAll: String cr with: String space) ]
		on: Error
		do: [ Text string: 'error printing' attribute: TextColor red ]! !

Object subclass: #GTSnippets
	instanceVariableNames: 'instance snippets'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-Inspector'!

GTSnippets class
	instanceVariableNames: 'instance'!

!GTSnippets commentStamp: '<historical>' prior: 0!
GTSnippets instance!

GTSnippets class
	instanceVariableNames: 'instance'!

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 14:55'!
instance
	^ instance ifNil: [ instance := self new ]! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 2/2/2014 14:05'!
reset
	instance := nil! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:00'!
snippetAt: anObject
	^ self instance snippetAt: anObject! !

!GTSnippets class methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 15:10'!
snippetAt: anObject put: aString
	^ self instance snippetAt: anObject put: aString! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 12/30/2013 23:44'!
snippetAt: anObject
	^ self snippets 
		at: anObject 
		ifAbsent: [ 'self' ]! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 12/30/2013 23:44'!
snippetAt: anObject put: aString
	^ self snippets 
		at: anObject 
		put: aString! !

!GTSnippets methodsFor: 'accessing' stamp: 'TudorGirba 11/27/2013 14:59'!
snippets 
	^ snippets ifNil: [ snippets := IdentityDictionary new ]! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/23/2013 09:12'!
gtDisplayOn: stream
	"This offers a means to customize how the object is shown in the inspector"
	^ self printOn: stream! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 12/28/2013 21:59'!
gtDisplayString
	"This offers a means to customize how the object is shown in the inspector.
	Do not override this method. Override gtDisplayOn: instead"
		
	| limitedString limit |
	limit := 1000.
	limitedString := String streamContents: [:s | self gtDisplayOn: s] limitedTo: limit.
	limitedString size < limit ifTrue: [^ limitedString].
	^ limitedString , ' ...'! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 22:51'!
gtInspectorMethodsIn: composite
	"This presentation offers the methods of the class of the current object"
	<gtInspectorPresentationOrder: 1000>
	composite custom: (GTSimpleMethodsBrowser new startOn: self) ! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 22:53'!
gtInspectorPresentationsIn: composite
	"This is a utility method that collects all presentations for the current object.
	By default, it simply looks for the #gtInspectorPresentationOrder: pragma.
	Subclasses might want to override it for more special behavior."
	| pragmas |
	pragmas := Pragma 
				allNamed: #gtInspectorPresentationOrder: 
				from: self class 
				to: Object 
				sortedUsing: [: x :y | (x argumentAt: 1) < (y argumentAt: 1)].
	pragmas do: [ :eachPragma | 
		self perform: eachPragma selector with: composite ]
! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 22:53'!
gtInspectorStateIn: composite
	"This is the most basic presentation showing the state of the object"
	<gtInspectorPresentationOrder: 10>
	composite custom: (GTObjectVariablesBrowser new startOn: self)! !

!Object methodsFor: '*gt-inspector' stamp: 'TudorGirba 1/28/2014 22:54'!
gtInspectorVariableValuePairs
	"This is a helper method that returns a collection of 
		variable_name -> value
	for the current object.
	Subclasses can override it to specialize what appears in the variables presentation"
	| bindings |
	bindings := self class allInstVarNames 
					collect: [ :iv | iv -> (self instVarNamed: iv) ].
	^ Set new
		addAll: bindings;
		yourself! !
GTInspector initialize!
